# Inspired by livna 
# stuff to be implemented externally:
Source10: kmodtool
%define   kmodtool bash %{SOURCE10}
# end stuff to be ...

# hardcode for now:
%{!?kversion: %define kversion 2.6.19-1.2895.fc6}

%define kmod_name ipw2200-ap
%define kverrel %(%{kmodtool} verrel %{?kversion} 2>/dev/null)

%define upvar ""
%ifarch i686
%define paevar PAE
%endif
%ifarch ppc
%define smpvar smp
%endif
%ifarch i686 x86_64
%define xenvar xen
%define kdumpvar kdump
%endif
%ifarch i686 x86_64 ppc
%define kdumpvar kdump
%endif
%{!?kvariants: %define kvariants %{?upvar} %{?smpvar} %{?paevar} %{?xenvar} %{?kdumpvar}}

Summary: Intel PRO/Wireless 2200 AP Driver for Linux..
Name: ipw2200-ap-kmod
Version: 0.3
Release: 0.3.%(echo %{kverrel} | tr - _)
License: GPL
Group:   System Environment/Kernel
URL:     http://sourceforge.net/projects/ipw2200-ap
Source0: http://prdownloads.sourceforge.net/ipw2200/ipw2200-ap-%{version}.tgz
## From: rick f <rickdic@ho...> - 2006-10-25 21:29
Patch0:  ipw2200-ap-wep_b-support.patch
Patch1:  ipw2200-ap-Makefile.patch
Patch2:  ipw2200-ap-0.3-ieee_inc.patch
Patch3:  ipw2200-ap-0.3-ipw_inc.patch
Patch4:  ipw2200-ap-0.3-ipw_IRQ.patch
BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
ExclusiveArch:	i586 i686

Requires: ipw2200-ap-kmod-common = %{version}


%description
This project was created by Intel to enable support for the Intel
PRO/Wireless 2200 Network Connection mini PCI adapter.

# magic hidden here:
%{expand:%(%{kmodtool} rpmtemplate %{kmod_name} %{kverrel} %{kvariants} 2>/dev/null)}


%description 
This project was created by Intel to enable support for the Intel
PRO/Wireless 2200 AP Network Connection mini PCI adapter.
This RPM contains a binary Linux kernel module build for %{kernel}.

%prep
%setup -c -q 
pushd %{kmod_name}-%{version}
#rm Makefile
#mv Makefile.i386 Makefile
perl -pi -e's,/sbin/depmod,:,g' Makefile

# Fake build into believing this kernel has no ipw2200
# We do this so that the ipw2200 Makefile sets its own defaults
perl -pi -e's,^(ifndef CONFIG_IPW2200),$1_off,' Makefile
%patch0 -p1
%patch1 -p1 -b -kh.patch
%patch2 -p1 -b -kh1.patch
%patch3 -p1 -b -kh2.patch
#%patch4 -p0
popd

grep -rlF 'config.h' %{kmod_name}-%{version} \
| xargs sed -i -e 's|config.h|autoconf.h|'
grep -rlF '"ipw2200"' %{kmod_name}-%{version} \
| xargs sed -i -e 's|"ipw2200"|"ipw2200-ap"|'
grep -rlF '<net/ieee80211.h>' %{kmod_name}-%{version} \
| xargs sed -i -e 's|<net/ieee80211.h>|"net/ieee80211.h"|'
grep -rlF '<net/ieee80211_crypt.h>' %{kmod_name}-%{version} \
| xargs sed -i -e 's|<net/ieee80211_crypt.h>|"net/ieee80211_crypt.h"|'
grep -rlF 'DEBUG=y' %{kmod_name}-%{version}/Makefile \
| xargs sed -i -e 's|DEBUG=y|DEBUG=n|'
grep -rlF '<asm/uaccess.h>' %{kmod_name}-%{version} \
| xargs sed -i -e 's|<asm/uaccess.h>|<linux/uaccess.h>|'
grep -rlF '<linux/tqueue.h>' %{kmod_name}-%{version} \
| xargs sed -i -e 's|<linux/tqueue.h>|<linux/workqueue.h>|'
grep -rlF '<asm/string.h>' %{kmod_name}-%{version} \
| xargs sed -i -e 's|<asm/string.h>|<linux/string.h>|'

for kvariant in %{kvariants} ; do
    cp -a -r %{kmod_name}-%{version} _kmod_build_$kvariant
done


%build

for kvariant in %{kvariants} ; do
pushd _kmod_build_$kvariant
ksrc=%{_usrsrc}/kernels/%{kverrel}${kvariant:+-$kvariant}-%{_target_cpu}
make -C ${ksrc} SUBDIRS=$(pwd)
popd
done


%install
rm -rf %{buildroot}
for kvariant in %{kvariants}
do
pushd _kmod_build_$kvariant
make \
  KSRC=%{_usrsrc}/kernels/%{kverrel}${kvariant:+-$kvariant}-%{_target_cpu} \
  KMISC=%{buildroot}/lib/modules/%{kverrel}${kvariant}/extra/%{kmod_name} \
install
popd
done

chmod u+x %{buildroot}/lib/modules/*/extra/%{kmod_name}/*


%clean
rm -rf %{buildroot}

%Changelog
* Tue Feb  6 2007 kwizart < kwizart at gmail.com > - 0.3-0.3
- WIP.

* Fri Jan 26 2007 kwizart < kwizart at gmail.com > - 0.3-0.2
- Work In Progress.

* Mon Dec 04 2006 kwizart < kwizart at gmail.com > - 0.3-0.1.kwizart.fc6
- Initial release

